Index: palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3556)
+++ palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3557)
@@ -1274,5 +1294,6 @@
            )
 
-           ! Allocate neighbour indices and weights
+!
+!--        Allocate neighbour indices and weights
            ALLOCATE( grid % ii(0:nx, 0:ny, 4),                                 &
                      grid % jj(0:nx, 0:ny, 4) )
@@ -1283,6 +1304,7 @@
            grid % w_horiz(:,:,:)   = 0.0_dp
         
-        ! This mode initializes a Cartesian PALM-4U grid and adds the
-        ! corresponding latitudes and longitudes of the rotated pole grid.
+!
+!--     This mode initializes a Cartesian PALM-4U grid and adds the
+!--     corresponding latitudes and longitudes of the rotated pole grid.
         CASE('palm')
 
@@ -1301,6 +1323,7 @@
            grid % name(3) = 'z'
 
-           !TODO: Remove use of global dx, dy, dz variables. Consider
-           !TODO:   associating global x,y, and z arrays.
+!
+!--        TODO: Remove use of global dx, dy, dz variables. Consider
+!--        TODO: associating global x,y, and z arrays.
            ALLOCATE( grid % x(0:nx),   grid % y(0:ny) )
            ALLOCATE( grid % xu(1:nx),  grid % yv(1:ny) )
@@ -1314,5 +1337,6 @@
            grid % depths => depths
 
-           ! Allocate neighbour indices and weights
+!
+!--        Allocate neighbour indices and weights
            IF (TRIM(ic_mode) .NE. 'profile')  THEN
               ALLOCATE( grid % kk(0:nx, 0:ny, 1:nz, 2) )
@@ -1329,6 +1353,7 @@
            grid % name(3) = 'interpolated hhl or hfl'
 
-           !TODO: Remove use of global dx, dy, dz variables. Consider
-           !TODO:   associating global x,y, and z arrays.
+!
+!--        TODO: Remove use of global dx, dy, dz variables. Consider
+!--        TODO: associating global x,y, and z arrays.
            ALLOCATE( grid % x(0:nx),   grid % y(0:ny) )
            ALLOCATE( grid % xu(1:nx),  grid % yv(1:ny) )
@@ -1340,11 +1365,13 @@
            grid % depths => depths
 
-           ! Allocate rotated-pole coordinates, clon is for (c)osmo-de (lon)gitude
+!
+!--        Allocate rotated-pole coordinates, clon is for (c)osmo-de (lon)gitude
            ALLOCATE( grid % clon(0:nx, 0:ny),   grid % clat(0:nx, 0:ny)  )
            ALLOCATE( grid % clonu(1:nx, 0:ny),  grid % clatu(1:nx, 0:ny) )
            ALLOCATE( grid % clonv(0:nx, 1:ny),  grid % clatv(0:nx, 1:ny) )
 
-           ! Compute rotated-pole coordinates of...
-           ! ... PALM-4U centres
+!
+!--        Compute rotated-pole coordinates of...
+!--        ... PALM-4U centres
            CALL rotate_to_cosmo(                                               &
               phir = project( grid % y, y0, EARTH_RADIUS ) , & ! = plate-carree latitude
@@ -1356,5 +1383,6 @@
            )
 
-           ! ... PALM-4U u winds
+!
+!--        ... PALM-4U u winds
            CALL rotate_to_cosmo(                                               &
               phir = project( grid % y,  y0, EARTH_RADIUS ), & ! = plate-carree latitude
@@ -1366,5 +1394,6 @@
            )
 
-           ! ... PALM-4U v winds
+!
+!--        ... PALM-4U v winds
            CALL rotate_to_cosmo(                                               &
               phir = project( grid % yv, y0, EARTH_RADIUS ), & ! = plate-carree latitude
@@ -1376,5 +1405,6 @@
            )
 
-           ! Allocate neighbour indices and weights
+!
+!--        Allocate neighbour indices and weights
            ALLOCATE( grid % ii(0:nx, 0:ny, 4),                                 &
                      grid % jj(0:nx, 0:ny, 4) )
@@ -1398,6 +1428,7 @@
            grid % latv(:) = grid % lat + 0.5_dp * (grid % ly / grid % ny)
 
-           ! Point to heights of half levels (hhl) and compute heights of full
-           ! levels (hfl) as arithmetic averages
+!
+!--        Point to heights of half levels (hhl) and compute heights of full
+!--        levels (hfl) as arithmetic averages
            grid % hhl => hhl
            grid % hfl => hfl
@@ -1472,11 +1503,13 @@
        avg_grid % kind = TRIM(kind)
 
-       ! Find and store COSMO columns that fall into the coordinate range
-       ! given by avg_grid % clon, % clat
+!
+!--    Find and store COSMO columns that fall into the coordinate range
+!--    given by avg_grid % clon, % clat
        CALL get_cosmo_averaging_region(avg_grid, cosmo_grid)
 
        ALLOCATE (avg_grid % kkk(avg_grid % n_columns, avg_grid % nz, 2) )
        ALLOCATE (avg_grid % w(avg_grid % n_columns, avg_grid % nz, 2) )
-       ! Compute average COSMO levels in the averaging region
+!
+!--    Compute average COSMO levels in the averaging region
        SELECT CASE(avg_grid % kind)
 
@@ -1494,5 +1527,6 @@
        END SELECT
 
-       ! For level-besed averaging, compute average heights
+!
+!--    For level-besed averaging, compute average heights
        level_based_averaging = .TRUE.
        IF (level_based_averaging)  THEN
@@ -1503,7 +1537,8 @@
        END IF
 
-       ! Copy averaged grid to all COSMO columns, leads to computing the same
-       ! vertical interpolation weights for all columns and to COSMO grid level
-       ! based averaging onto the averaged COSMO heights.
+!
+!--    Copy averaged grid to all COSMO columns, leads to computing the same
+!--    vertical interpolation weights for all columns and to COSMO grid level
+!--    based averaging onto the averaged COSMO heights.
        IF ( TRIM(cfg % averaging_mode) == 'level' )  THEN
           FORALL(                                                              &
@@ -1513,5 +1548,6 @@
        END IF
 
-       ! Compute vertical weights and neighbours
+!
+!--    Compute vertical weights and neighbours
        CALL find_vertical_neighbours_and_weights_average(avg_grid)
 
@@ -1550,6 +1586,6 @@
        END SELECT
 
-
-       ! FIXME: make dlon, dlat parameters of the grid_defintion type
+!
+!--    FIXME: make dlon, dlat parameters of the grid_defintion type
        dlon = cosmo_lon(1) - cosmo_lon(0)
        dlat = cosmo_lat(1) - cosmo_lat(0)
@@ -1610,8 +1646,9 @@
        REAL(dp) ::  dz_level_end, dz_stretched
 
-       INTEGER ::  dz_stretch_level_end_index(9)               !< vertical grid level index until which the vertical grid spacing is stretched
-       INTEGER ::  dz_stretch_level_start_index(9)             !< vertical grid level index above which the vertical grid spacing is stretched
+       INTEGER ::  dz_stretch_level_end_index(9)      !< vertical grid level index until which the vertical grid spacing is stretched
+       INTEGER ::  dz_stretch_level_start_index(9)    !< vertical grid level index above which the vertical grid spacing is stretched
        INTEGER ::  dz_stretch_level_index = 0
        INTEGER ::  k, n, number_dz
+
 !
 !-- Compute height of u-levels from constant grid length and dz stretch factors
@@ -1826,4 +1863,5 @@
 
 
+!------------------------------------------------------------------------------!
 ! Description: [PALM subroutine]
 ! -----------------------------------------------------------------------------!
@@ -1936,8 +1974,8 @@
              
 !
-!--                stretch_factor_1 is taken to guarantee that the stretching
-!--                procedure ends as close as possible to dz_stretch_level_end.
-!--                stretch_factor_2 would guarantee that the stretched dz(n) is
-!--                equal to dz(n+1) after l_rounded grid levels.
+!--          stretch_factor_1 is taken to guarantee that the stretching
+!--          procedure ends as close as possible to dz_stretch_level_end.
+!--          stretch_factor_2 would guarantee that the stretched dz(n) is
+!--          equal to dz(n+1) after l_rounded grid levels.
              IF (delta_total_new < delta_total_old) THEN
                 dz_stretch_factor_array(n) = stretch_factor_1
@@ -1974,4 +2012,10 @@
  END SUBROUTINE calculate_stretching_factor
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Computes the midpoint between two neighbouring coordinates in the given
+!> coordinate vector 'z' and stores it in 'zw'.
+!------------------------------------------------------------------------------!
     SUBROUTINE midpoints(z, zw)
 
@@ -1987,5 +2031,9 @@
     END SUBROUTINE midpoints
 
-
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Defines INFOR's IO groups.
+!------------------------------------------------------------------------------!
     SUBROUTINE setup_io_groups()
 
@@ -1994,6 +2042,7 @@
        ngroups = 16
        ALLOCATE( io_group_list(ngroups) )
-       
-       !soil temp
+
+!
+!--    soil temp
        io_group_list(1) = init_io_group(                                       &
           in_files = soil_files,                                               &
@@ -2003,5 +2052,6 @@
        )
 
-       !soil water
+!
+!--    soil water
        io_group_list(2) = init_io_group(                                       &
           in_files = soil_files,                                               &
@@ -2011,6 +2061,7 @@
        )
 
-       !potential temperature, surface pressure, specific humidity including
-       !nudging and subsidence, and geostrophic winds ug, vg
+!
+!--    potential temperature, surface pressure, specific humidity including
+!--    nudging and subsidence, and geostrophic winds ug, vg
        io_group_list(3) = init_io_group(                                       &
           in_files = flow_files,                                               &
@@ -2025,5 +2076,6 @@
        )
 
-       !Moved to therodynamic io_group
+!
+!--    Moved to therodynamic io_group
        !io_group_list(4) = init_io_group(                                       &
        !   in_files = flow_files,                                               &
@@ -2033,5 +2085,6 @@
        !)
 
-       !u and v velocity, ug anv vg moved to thermodynamic io group. 
+!
+!--    u and v velocity
        io_group_list(5) = init_io_group(                                       &
           in_files = flow_files,                                               &
@@ -2043,5 +2096,6 @@
        )
    
-       !!v velocity, deprecated!
+!
+!--    v velocity, deprecated!
        !io_group_list(6) = init_io_group(                                       &
        !   in_files = flow_files,                                               &
@@ -2052,5 +2106,6 @@
        !io_group_list(6) % to_be_processed = .FALSE.
    
-       !w velocity and subsidence and w nudging
+!
+!--    w velocity and subsidence and w nudging
        io_group_list(7) = init_io_group(                                       &
           in_files = flow_files,                                               &
@@ -2059,6 +2114,6 @@
           kind = 'scalar'                                                      &
        )
-
-       !rain
+!
+!--    rain
        io_group_list(8) = init_io_group(                                       &
           in_files = soil_moisture_files,                                      &
@@ -2068,6 +2123,6 @@
        )
        io_group_list(8) % to_be_processed = .FALSE.
-
-       !snow
+!
+!--    snow
        io_group_list(9) = init_io_group(                                       &
           in_files = soil_moisture_files,                                      &
@@ -2077,6 +2132,6 @@
        )
        io_group_list(9) % to_be_processed = .FALSE.
-
-       !graupel
+!
+!--    graupel
        io_group_list(10) = init_io_group(                                      &
           in_files = soil_moisture_files,                                      &
@@ -2086,6 +2141,6 @@
        )
        io_group_list(10) % to_be_processed = .FALSE.
-
-       !evapotranspiration
+!
+!--    evapotranspiration
        io_group_list(11) = init_io_group(                                      &
           in_files = soil_moisture_files,                                      &
@@ -2095,6 +2150,6 @@
        )
        io_group_list(11) % to_be_processed = .FALSE.
-
-       !2m air temperature
+!
+!--    2m air temperature
        io_group_list(12) = init_io_group(                                      &
           in_files = soil_moisture_files,                                      &
@@ -2103,6 +2158,6 @@
           kind = 'surface'                                                     &
        )
-
-       !incoming diffusive sw flux
+!
+!--    incoming diffusive sw flux
        io_group_list(13) = init_io_group(                                      &
           in_files = radiation_files,                                          &
@@ -2112,6 +2167,6 @@
        )
        io_group_list(13) % to_be_processed = .FALSE.
-
-       !incoming direct sw flux
+!
+!--    incoming direct sw flux
        io_group_list(14) = init_io_group(                                      &
           in_files = radiation_files,                                          &
@@ -2121,6 +2176,6 @@
        )
        io_group_list(14) % to_be_processed = .FALSE.
-
-       !sw radiation balance
+!
+!--    sw radiation balance
        io_group_list(15) = init_io_group(                                      &
           in_files = radiation_files,                                          &
@@ -2130,6 +2185,6 @@
        )
        io_group_list(15) % to_be_processed = .FALSE.
-
-       !lw radiation balance
+!
+!--    lw radiation balance
        io_group_list(16) = init_io_group(                                      &
           in_files = radiation_files,                                          &
@@ -2143,4 +2198,15 @@
 
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initializes an IO group with the list of input files, the lists of
+!> input and output variables, and sets the number of output quantities.
+!>
+!> In this context, output quantities refers to the physical quantities required
+!> to interpolate netCDF output variables, not the output variables itsleft. For
+!> instance, the output variables ls_forcing_left/_right/_north/_south all rely
+!> on the output quantity Theta.
+!------------------------------------------------------------------------------!
     FUNCTION init_io_group(in_files, out_vars, in_var_list, kind,              &
                            n_output_quantities) RESULT(group)
@@ -2157,5 +2223,11 @@
        group % n_inputs = SIZE(in_var_list)
        group % kind = TRIM(kind)
-
+!
+!--    For the 'thermodynamics' IO group, one quantity more than input variables
+!--    is needed to compute all output variables of the IO group. Concretely, in
+!--    preprocess() the density is computed from T,P or PP,QV in adddition to
+!--    the variables Theta, p, qv. In read_input_variables(),
+!--    n_output_quantities is used to allocate the correct number of input
+!--    buffers.
        IF ( PRESENT(n_output_quantities) )  THEN
           group % n_output_quantities = n_output_quantities
@@ -2207,5 +2279,5 @@
 ! Description:
 ! ------------
-!> Initializes the the variable list.
+!> Initializes the variable list.
 !------------------------------------------------------------------------------!
     SUBROUTINE setup_variable_tables(ic_mode)
@@ -2787,5 +2859,5 @@
           intermediate_grid = palm_intermediate                                &
        )
-       ! Radiation fluxes and balances
+
        output_var_table(38) = init_nc_var(                                     &
           name              = 'rad_swd_dif_0',                                 &
@@ -3154,5 +3226,6 @@
        output_var_table(64) % to_be_processed = .NOT. cfg % ug_is_set
 
-       ! Attributes shared among all variables
+!
+!--    Attributes shared among all variables
        output_var_table(:) % source = nc_source_text
 
@@ -3164,5 +3237,5 @@
 ! Description:
 ! ------------
-!> Initializes and nc_var varible with the given parameters. The 'kind'
+!> Initializes an nc_var varible with the given parameters. The 'kind'
 !> parameter is used to infer the correct netCDF IDs and the level of detail,
 !> 'lod', as defined by the PALM-4U input data standard.
@@ -3199,7 +3272,8 @@
        SELECT CASE( TRIM(out_var_kind) )
 
-       !TODO: Using global module variables 'init_variables_required' and
-       !TODO: 'boundary_variables_required'. Encapsulate in settings type
-       !TODO: and pass into init_nc_var.
+!
+!--    TODO: Using global module variables 'init_variables_required' and
+!--    TODO: 'boundary_variables_required'. Encapsulate in settings type
+!--    TODO: and pass into init_nc_var.
        CASE( 'init soil' )
           var % nt              = 1
@@ -3591,8 +3665,10 @@
        
        CASE( 'velocities' )
-          ! Allocate a compute buffer with the same number of arrays as the input
+!
+!--       Allocate a compute buffer with the same number of arrays as the input
           ALLOCATE( preprocess_buffer( SIZE(input_buffer) ) )
 
-          ! Allocate u and v arrays with scalar dimensions
+!
+!--       Allocate u and v arrays with scalar dimensions
           nx = SIZE(input_buffer(1) % array, 1)
           ny = SIZE(input_buffer(1) % array, 2)
@@ -3603,5 +3679,6 @@
  CALL run_control('time', 'alloc')
 
-          ! interpolate U and V to centres
+!
+!--       interpolate U and V to centres
           CALL centre_velocities( u_face = input_buffer(1) % array,            &
                                   v_face = input_buffer(2) % array,            &
@@ -3613,6 +3690,7 @@
 
           CASE('rotated-pole')
-             ! rotate U and V to PALM-4U orientation and overwrite U and V with
-             ! rotated velocities
+!
+!--          rotate U and V to PALM-4U orientation and overwrite U and V with
+!--          rotated velocities
              DO k = 1, nz
              DO j = 1, ny
@@ -3637,5 +3715,4 @@
           END SELECT
 
-          ! set values 
           input_buffer(1) % array(1,:,:) = 0.0_dp
           input_buffer(2) % array(1,:,:) = 0.0_dp
@@ -3658,5 +3735,6 @@
           nz = SIZE(input_buffer(1) % array, 3)
 
-          ! Compute absolute pressure if presure perturbation has been read in.
+!
+!--       Compute absolute pressure if presure perturbation has been read in.
           IF ( TRIM(group % in_var_list(2) % name) == 'PP' )  THEN
              message = "Absolute pressure, P, not available, " //              &
@@ -3673,4 +3751,7 @@
                                      RD, G, basic_state_pressure)
 
+!
+!--             Overwrite pressure perturbation with absolute pressure. HECTO
+!--             converts pressure perturbation from hPa to Pa.
                 input_buffer (2) % array(i,j,:) =                              &
                    HECTO * input_buffer (2) % array(i,j,:) +                   &
@@ -3687,8 +3768,10 @@
 
           END IF
-          ! pressure
+!
+!--       mark pressure as preprocessed
           input_buffer(2) % is_preprocessed = .TRUE.
 
-          ! Copy temperature to last input buffer array
+!
+!--       Copy temperature to the last input buffer array
           ALLOCATE(                                                            &
               input_buffer( group % n_output_quantities ) % array (nx, ny, nz) &
@@ -3697,5 +3780,6 @@
               input_buffer(1) % array(:,:,:)
 
-          ! Convert absolute to potential temperature
+!
+!--       Convert absolute in place to potential temperature
           CALL potential_temperature(                                          &
              t = input_buffer(1) % array(:,:,:),                               &
@@ -3706,8 +3790,10 @@
           )
 
-          ! potential temperature
+!
+!--       mark potential temperature as preprocessed
           input_buffer(1) % is_preprocessed = .TRUE.
 
-          ! Convert temperature copy to density
+!
+!--       Convert temperature copy to density
           CALL moist_density(                                                  &
              t_rho = input_buffer(group % n_output_quantities) % array(:,:,:), &
@@ -3718,8 +3804,10 @@
           )
 
-          ! qv
+!
+!--       mark qv as preprocessed
           input_buffer(3) % is_preprocessed = .TRUE.
 
-          ! density
+!
+!--       mark density as preprocessed
           input_buffer(group % n_output_quantities) % is_preprocessed = .TRUE.
 
@@ -3780,27 +3868,32 @@
           SELECT CASE(dt)
 
+!
+!--       input has been accumulated over one hour. Leave as is
+!--       input_buffer(1) % array(:,:,:) carrries one-hour integral
           CASE(1)
-             !input has been accumulated over one hour. Leave as is
-             !input_buffer(1) % array(:,:,:) carrries one-hour integral
-
+
+!
+!--       input has been accumulated over two hours. Subtract previous step
+!--       input_buffer(1) % array(:,:,:) carrries one-hour integral
+!--       input_buffer(2) % array(:,:,:) carrries two-hour integral
           CASE(2)
-             !input has been accumulated over two hours. Subtract previous step
-             !input_buffer(1) % array(:,:,:) carrries one-hour integral
-             !input_buffer(2) % array(:,:,:) carrries two-hour integral
              CALL deaverage(                                                   &
                       avg_1 = input_buffer(1) % array(:,:,:), t1 = 1.0_dp,     &
                       avg_2 = input_buffer(2) % array(:,:,:), t2 = 1.0_dp,     &
                       avg_3 = input_buffer(1) % array(:,:,:), t3 = 1.0_dp )
-             !input_buffer(1) % array(:,:,:) carrries one-hour integral of second hour
-
+!
+!--          input_buffer(1) % array(:,:,:) carrries one-hour integral of second hour
+
+!
+!--       input has been accumulated over three hours. Subtract previous step
+!--       input_buffer(1) % array(:,:,:) carrries three-hour integral
+!--       input_buffer(2) % array(:,:,:) still carrries two-hour integral
           CASE(3)
-             !input has been accumulated over three hours. Subtract previous step
-             !input_buffer(1) % array(:,:,:) carrries three-hour integral
-             !input_buffer(2) % array(:,:,:) still carrries two-hour integral
              CALL deaverage(                                                   &
                      avg_1 = input_buffer(2) % array(:,:,:), t1 = 1.0_dp,      &
                      avg_2 = input_buffer(1) % array(:,:,:), t2 = 1.0_dp,      &
                      avg_3 = input_buffer(1) % array(:,:,:), t3 = 1.0_dp )
-             !input_buffer(1) % array(:,:,:) carrries one-hour integral of third hourA
+!
+!--          input_buffer(1) % array(:,:,:) carrries one-hour integral of third hourA
 
           CASE DEFAULT
@@ -3818,28 +3911,34 @@
 
           hour = iter - 1
-          dt = MODULO(hour, 3) + 1 ! averaging period
+!
+!--       averaging period
+          dt = MODULO(hour, 3) + 1
           SELECT CASE(dt)
-
+!
+!--       input has been accumulated over one hour. Leave as is
+!--       input_buffer(1) % array(:,:,:) carrries one-hour integral
           CASE(1)
-             !input has been accumulated over one hour. Leave as is
-             !input_buffer(1) % array(:,:,:) carrries one-hour integral
-
+
+!
+!--       input has been accumulated over two hours. Subtract previous step
+!--       input_buffer(1) % array(:,:,:) carrries one-hour integral
+!--       input_buffer(2) % array(:,:,:) carrries two-hour integral
           CASE(2)
-             !input has been accumulated over two hours. Subtract previous step
-             !input_buffer(1) % array(:,:,:) carrries one-hour integral
-             !input_buffer(2) % array(:,:,:) carrries two-hour integral
              CALL deaverage( input_buffer(1) % array(:,:,:), 1.0_dp,           &
                              input_buffer(2) % array(:,:,:), 2.0_dp,           &
                              input_buffer(1) % array(:,:,:), 1.0_dp)
-             !input_buffer(1) % array(:,:,:) carrries one-hour integral of second hour
-
+!
+!--          input_buffer(1) % array(:,:,:) carrries one-hour integral of second hour
+
+!
+!--       input has been accumulated over three hours. Subtract previous step
+!--       input_buffer(1) % array(:,:,:) carrries three-hour integral
+!--       input_buffer(2) % array(:,:,:) still carrries two-hour integral
           CASE(3)
-             !input has been accumulated over three hours. Subtract previous step
-             !input_buffer(1) % array(:,:,:) carrries three-hour integral
-             !input_buffer(2) % array(:,:,:) still carrries two-hour integral
              CALL deaverage( input_buffer(2) % array(:,:,:), 2.0_dp,           &
                              input_buffer(1) % array(:,:,:), 3.0_dp,           &
                              input_buffer(1) % array(:,:,:), 1.0_dp)
-             !input_buffer(1) % array(:,:,:) carrries one-hour integral of third hourA
+!
+!--          input_buffer(1) % array(:,:,:) carrries one-hour integral of third hourA
 
           CASE DEFAULT
@@ -3860,4 +3959,5 @@
 
 
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -3928,5 +4028,6 @@
                 END DO
 
-                ! Overwrite if at least one non-water neighbour cell is available
+!
+!--             Overwrite if at least one non-water neighbour cell is available
                 IF (n_cells > 0)  THEN
                    array(i,j,:) = column(:) / n_cells
